package adminModel

import "gopkg.in/guregu/null.v4"

type FirewallGlobalInfo struct {
	ID     int64  `xorm:"id pk autoincr" json:"id"`
	Name   string `xorm:"name"`
	Enable string `xorm:"enable"`
}

func (*FirewallGlobalInfo) TableName() string {
	return "t_firewall_global"
}

type FirewallAutoDefenceRuleVO struct {
	Name        string `xorm:"name" json:"name"`
	Port        int64  `xorm:"port" json:"port"`
	Protocol    string `xorm:"protocol" json:"protocol"`
	PacketCount int64  `xorm:"packet_count" json:"packetCount"`
	Interval    int64  `xorm:"time_interval" json:"interval"`
}

type FirewallAutoDefenceRule struct {
	ID                        int64 `xorm:"id pk autoincr" json:"id"`
	FirewallAutoDefenceRuleVO `xorm:"extends"`
}

func (*FirewallAutoDefenceRule) TableName() string {
	return "t_firewall_auto_defence"
}

type FirewallCommonRule struct {
	ID        int64       `xorm:"id pk autoincr" json:"id"`
	Name      null.String `xorm:"name" json:"name"`
	StartPort string      `xorm:"start_port" json:"startPort"`
	EndPort   string      `xorm:"end_port" json:"endPort"`
	Protocol  null.String `xorm:"protocol" json:"protocol"`
	Ip        null.String `xorm:"ip" json:"ip"`
	Netmask   null.String `xorm:"netmask" json:"netmask"`
	Mac       null.String `xorm:"mac" json:"mac"`
	Action    null.String `xorm:"rule_action" json:"action"`
	Priority  int64       `xorm:"priority" json:"priority"`
}

func (*FirewallCommonRule) TableName() string {
	return " t_firewall_common"
}

type GeoipRule struct {
	ID          int64  `xorm:"id pk autoincr" json:"id"`
	CountryName string `xorm:"country_name" json:"countryName"`
}

func (*GeoipRule) TableName() string {
	return " t_firewall_geoip"
}

type GeoIPNames struct {
	Names []GeoipRule `json:"names"`
}

type FailToBan struct {
	ID       int64  `xorm:"id pk autoincr" json:"id"`
	Name     string `xorm:"name" json:"name"`
	Enable   bool   `xorm:"enable" json:"enable"`
	MaxRetry int64  `xorm:"max_retry" json:"maxRetry"`
	FindTime int64  `xorm:"find_time" json:"findTime"`
	BanTime  int64  `xorm:"ban_time" json:"banTime"`
}

func (*FailToBan) TableName() string {
	return " t_fail2ban_basic"
}

type FailToBanIgnored struct {
	ID            int64  `xorm:"id pk autoincr" json:"id"`
	Name          string `xorm:"name" json:"name"`
	Enable        int    `xorm:"enable" json:"enable"`
	Https         int    `xorm:"protocol_https" json:"https"`
	Iax           int    `xorm:"protocol_iax" json:"iax"`
	Sip           int    `xorm:"protocol_sip" json:"sip"`
	Ssh           int    `xorm:"protocol_ssh" json:"ssh"`
	Ip            string `xorm:"ip" json:"ip"`
	Netmask       string `xorm:"netmask" json:"netmask"`
	NetmaskLength int    `xorm:"netmask_length"`
}

func (*FailToBanIgnored) TableName() string {
	return " t_fail2ban_ignored"
}

type UpdatePriority struct {
	Action string `json:"action"`
	ID     int64  `json:"id"`
}
