package weblog

import (
	"fmt"
	"os"
	"time"

	"github.com/sirupsen/logrus"
)

var fail2banLog = "/var/log/invalid_web_visit.log"

func AuthError(ip, msg string) {
	f, err := os.OpenFile(fail2banLog, os.O_APPEND|os.O_CREATE|os.O_WRONLY, 0644)
	if err != nil {
		logrus.Error("auth open error", err)
	}
	defer f.Close()
	context := fmt.Sprintf("%s pbx api auth error from '%s', msg: %s\n", time.Now(), ip, msg)
	if _, err := f.Write([]byte(context)); err != nil {
		logrus.Error("auth write error", err)
	}
}
